function [C, w] = bow_dictionary(shapes, dsize)

if(nargin<2)
    dsize = 128
end

%concat all shapes' descriptors in the same matrix
descriptors = [];
for si=1:numel(shapes)
    descriptors = [descriptors; real(shapes{si}.desc)];
end


%kmeans clustering
C=[];
mkeep=-100;
for r=1:5
    [idx,Cc] = kmeans(descriptors, floor(dsize),'MaxIter',200,'Distance','cityblock');
    for ci = 1:max(idx)
        if(sum(idx==ci)==1)
            Cc(ci,:) = (descriptors(idx==ci,:));
        else
            Cc(ci,:) = mean(descriptors(idx==ci,:));
        end
    end
    
    f=hist(idx,1:dsize);
    keep = f<mean(f)+10*std(f);
    if(sum(keep)>mkeep)
        C=Cc;
        mkeep=sum(keep);
    end
end

kdt = KDTreeSearcher(C);
[idx, D] = knnsearch(kdt, descriptors,'Distance','cityblock');
w=1./(hist(idx,1:dsize)./numel(idx));
