function M = calc_shape_descriptors(M)

    M.times = linspace(-16,-6,80);
    
    %rescale shape
    M.VERT=M.VERT./max(range(M.VERT));

    [M.evecs, M.evals, M.S,M.W] = calc_LB(M, min(M.n-2,300));
    keep=M.evals>1e-10;
    M.evals=M.evals(keep);
    M.evecs=M.evecs(:,keep);


    M.HKS = calc_HKS(M,2.^M.times);
    
    %%calc fps extrema avoiding shape border
    [ c,d,I,bv ] = get_boundary( M.TRIV );
    M.fps_h = fps_extrema(M,200);
    selfps = ~ismember(M.fps_h,bv);
    M.fps = M.fps_h(selfps);

    %% add some euclidean fps untill target fps number is reached
    n_fps=20;
    while(numel(M.fps)<20)
        M.fps = [M.fps; unique(fps_euclidean(M.VERT,n_fps,1))];
        selfps = ~ismember(M.fps,bv);
        M.fps = M.fps(selfps);
        n_fps=n_fps+10;
    end
     
    fprintf('Computing HKSp on  %d points\n',numel(M.fps));
    M.HKSpade = calc_Hks_pade_local(M,2.^M.times,M.fps');

end