clear all
close all
clc
addpath(genpath('.'));

data_dir = 'small_training_set/';

%% compute descriptors
shapes = load_shapes(data_dir);

%% bow_dictionary
dsize = 128; %dictionary size
[C,w] = bow_dictionary(shapes, dsize);

%% bow_retrieval
D= bow_retrieval(shapes,C,w);
D=D+D';
D=D./max(D(:));
D=D-diag(diag(D));
imagesc(D)
caxis([min(D(~logical(eye(size(D))))),max(D(~logical(eye(size(D)))))])

%% evaluate
mkdir eval;

f=fopen('eval/D.bin','w');
fwrite(f,D,'single');
fclose(f);

copyfile([data_dir '\classes.cla'], 'eval\classes.cla');

system('psbPlot.exe eval/classes.cla eval/D.bin')

curveD = importdata('D.bin.plot');

plot(curveD(3:end,1),curveD(3:end,2),'.-','LineWidth',2,'MarkerSize',20);
hold off
grid on
axis([0 1 0 1])
% axis equal
xlabel('Recall')
ylabel('Precision')

