function D = geo_dist_to_all(M, samples)

M.n = size(M.VERT,1);
ns = length(samples);
D = inf(M.n, ns);

march = fastmarchmex('init', int32(M.TRIV-1), double(M.VERT(:,1)), double(M.VERT(:,2)), double(M.VERT(:,3)));

for i=1:ns
    source = inf(M.n,1);
    source(samples(i)) = 0;
    D(:,i) = fastmarchmex('march', march, double(source));
end

fastmarchmex('deinit', march);

end
