function shapes = load_shapes(data_dir)

shapes = {};
%% load shapes with precomputed descriptors
files = dir([data_dir '*.off']);
for fi=1:numel(files)
    fname = files(fi).name;
    [~,name,~] = fileparts(fname);
    if(exist([data_dir name '.mat'],'file'))
        load([data_dir name '.mat']);       
    elseif(exist([data_dir name '.off'],'file'))
        M = load_off([data_dir name '.off']);
        M = calc_shape_descriptors(M);
    end
    if(exist('M','var'))
        HKSres = M.HKSpade(:,1:end);
        dh = (log(HKSres(:,2:end))-log(HKSres(:,1:end-1)))./(M.times(2)-M.times(1));

        dh2=diff(dh')';
        dd=sign(dh2(:,1));
        dh2=repmat(dd,1,size(dh2,2)).*dh2;

        M.desc=[];
        for i=1:size(dh,1)
            shift = min([find(dh2(i,:)<0,1),60]);    
            M.desc(i,:)=dh(i,shift:(shift+19));
        end
        save([data_dir name '.mat'],'M');
        shapes{fi} = M;
    end
    
   
end

end